#include "systemc.h"

struct SomeError
{
  int e;
};

struct SomeFault
{
  int f;
};

class TryCatch: public sc_module {
public:
  SomeError some_error;
  SomeFault some_fault;

  SC_HAS_PROCESS(TryCatch);

  void try_catch_1()
  {
    wait();
    char aaa = 'a';
    try {
      char bbb = 'b';
    }
    catch(SomeError) {
      char ccc = 'c';
    }
    char ddd = 'd';
  }

  void try_catch_2()
  {
    wait();
    int aaa;
    try {
      int bbb;
      wait();
      int ccc;
    }
    catch(SomeFault) {
      int ddd;
    }
    int eee;
  }

  void try_catch_3()
  {
    wait();
    int aaa;
    try {
      int bbb;
      wait();
      int ccc;
    }
    catch(SomeError) {
      int ddd;
    }
    catch(SomeFault) {
      int eee;
    }
    int fff;
  }

  void try_catch_4()
  {
    wait();
    int aaa;
    try {
      int bbb;
      wait();
      int ccc;
    }
    catch(SomeError) {
      int ddd;
      wait();
      int eee;
    }
    catch(SomeFault) {
      int fff;
    }
    int ggg;
  }

  void try_catch_5()
  {
    wait();
    int aaa;
    try {
      int bbb;
      throw some_error; int never_reached;  // TODO
      wait();
      int ccc;
    }
    catch(SomeError) {
      int ddd;
      wait();
      int eee;
    }
    catch(SomeFault) {
      int fff;
    }
    int ggg;
  }

  TryCatch(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(try_catch_1);
    SC_THREAD(try_catch_2);
    SC_THREAD(try_catch_3);
    SC_THREAD(try_catch_4);
    SC_THREAD(try_catch_5);
  }
};

#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  TryCatch mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
