#include "hierarchical_channel_instance.h"

risc::HierarchicalChannelInstance::HierarchicalChannelInstance(
    SgVariableDefinition *ast_node,
    HierarchicalChannel *ir_def):
  ModuleInstance(ast_node, HierarchicalChannelInstanceType),
  channel_definition_(ir_def)
{
  if(ir_def == NULL) {
    assert(0);
  }
  channel_definition_->instances_.push_back(this);
}

risc::HierarchicalChannel* risc::HierarchicalChannelInstance::get_definition()
{
  return channel_definition_;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
